# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Network
  module Models
    #
    # DHCPOptions contains an array of DNS servers available to VMs deployed
    # in the virtual networkStandard DHCP option for a subnet overrides VNET
    # DHCP options.
    #
    class DhcpOptions

      include MsRestAzure

      # @return [Array<String>] Gets or sets list of DNS servers IP addresses
      attr_accessor :dns_servers

      #
      # Validate the object. Throws ValidationError if validation fails.
      #
      def validate
        @dns_servers.each{ |e| e.validate if e.respond_to?(:validate) } unless @dns_servers.nil?
      end

      #
      # Serializes given Model object into Ruby Hash.
      # @param object Model object to serialize.
      # @return [Hash] Serialized object in form of Ruby Hash.
      #
      def self.serialize_object(object)
        object.validate
        output_object = {}

        serialized_property = object.dns_servers
        output_object['dnsServers'] = serialized_property unless serialized_property.nil?

        output_object
      end

      #
      # Deserializes given Ruby Hash into Model object.
      # @param object [Hash] Ruby Hash object to deserialize.
      # @return [DhcpOptions] Deserialized object.
      #
      def self.deserialize_object(object)
        return if object.nil?
        output_object = DhcpOptions.new

        deserialized_property = object['dnsServers']
        output_object.dns_servers = deserialized_property

        output_object.validate

        output_object
      end
    end
  end
end
