# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Resources
  module Models
    #
    # Resource provider information.
    #
    class Provider

      include MsRestAzure

      # @return [String] Gets or sets the provider id.
      attr_accessor :id

      # @return [String] Gets or sets the namespace of the provider.
      attr_accessor :namespace

      # @return [String] Gets or sets the registration state of the provider.
      attr_accessor :registration_state

      # @return [Array<ProviderResourceType>] Gets or sets the collection of
      # provider resource types.
      attr_accessor :resource_types

      #
      # Validate the object. Throws ValidationError if validation fails.
      #
      def validate
        @resource_types.each{ |e| e.validate if e.respond_to?(:validate) } unless @resource_types.nil?
      end

      #
      # Serializes given Model object into Ruby Hash.
      # @param object Model object to serialize.
      # @return [Hash] Serialized object in form of Ruby Hash.
      #
      def self.serialize_object(object)
        object.validate
        output_object = {}

        serialized_property = object.id
        output_object['id'] = serialized_property unless serialized_property.nil?

        serialized_property = object.namespace
        output_object['namespace'] = serialized_property unless serialized_property.nil?

        serialized_property = object.registration_state
        output_object['registrationState'] = serialized_property unless serialized_property.nil?

        serialized_property = object.resource_types
        unless serialized_property.nil?
          serializedArray = []
          serialized_property.each do |element|
            unless element.nil?
              element = ProviderResourceType.serialize_object(element)
            end
            serializedArray.push(element)
          end
          serialized_property = serializedArray
        end
        output_object['resourceTypes'] = serialized_property unless serialized_property.nil?

        output_object
      end

      #
      # Deserializes given Ruby Hash into Model object.
      # @param object [Hash] Ruby Hash object to deserialize.
      # @return [Provider] Deserialized object.
      #
      def self.deserialize_object(object)
        return if object.nil?
        output_object = Provider.new

        deserialized_property = object['id']
        output_object.id = deserialized_property

        deserialized_property = object['namespace']
        output_object.namespace = deserialized_property

        deserialized_property = object['registrationState']
        output_object.registration_state = deserialized_property

        deserialized_property = object['resourceTypes']
        unless deserialized_property.nil?
          deserializedArray = [];
          deserialized_property.each do |element1|
            unless element1.nil?
              element1 = ProviderResourceType.deserialize_object(element1)
            end
            deserializedArray.push(element1);
          end
          deserialized_property = deserializedArray;
        end
        output_object.resource_types = deserialized_property

        output_object.validate

        output_object
      end
    end
  end
end
